/* Copyright 2004,2005,2006 Thomas "thisnukes4u" Coppi
   If you use this program, please send me an e-mail at thisnukes4u@gmail.com
   You may do whatever you wish with this program except for selling it, claiming it as your own,
   or modifying it without releasing the source code (the listed restrictions are not mutally exclusive,
   they all apply). If you do not agree with the above terms, you may optionally distribute and use 
   this software under the GNU GPL, the terms of which are included in the COPYING file */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "config.h"
#include "conf.h"

Config temp_conf;

/* Implements a simple config file parser
   It is quick and to the point, if a bit repetitive :/ */
Config *read_config(char *location)
{
	FILE *fp;
	int i;
	char text[101],temp[101];

	/* Set default config values */
	strcpy(temp_conf.feed_loc,"null");
	temp_conf.update = 15;
	temp_conf.font_size_i = 12;
	strcat(temp_conf.font_size,"12");
	strcpy(temp_conf.title,"a");
	strcpy(temp_conf.lcolor,"blue");
	temp_conf.decorated = TRUE;
	gdk_color_parse("white",&temp_conf.bgcolor);
	gdk_color_parse("black",&temp_conf.fgcolor);
	temp_conf.sfgcolor = strdup("black");
	temp_conf.noquit = 0;
	temp_conf.geom_x = 275;
	temp_conf.geom_y = 125;
	temp_conf.log = 0;
	
	/* open the file */
	if((fp = fopen(location,"r")) == NULL) exit(1);
	
	while(1) {	
		/* read in the first line */
		fgets(text,100,fp);
		if(feof(fp)) break;	
		
		/* parse the line */
		if(!strncmp(text,"title",5)) {
			for(i=6;i<strlen(text)-1;i++) {
				temp_conf.title[i-6] = text[i];
			}
		}
		else if(!strncmp(text,"feed",4)) {	
			strncpy(temp_conf.feed_loc,"",4);
			for(i=5;i<strlen(text)-1;i++) {
				temp_conf.feed_loc[i-5] = text[i];
			}
		}
		else if(!strncmp(text,"update",6)) {
			for(i=7;i<strlen(text)-1;i++) {
				temp[i-7] = text[i];
			}
			temp_conf.update = atoi(temp);
		}
		else if(!strncmp(text,"face",4)) {
			for(i=5;i<strlen(text)-1;i++) {	
				temp_conf.font_face[i-5] = text[i];
			}
			strcat(temp_conf.font_face," ");	
		}
		else if(!strncmp(text,"size",4)) {
			strncpy(temp_conf.font_size,"",2);
			for(i=5;i<strlen(text)-1;i++) {
				temp_conf.font_size[i-5] = text[i];
			}
			temp_conf.font_size_i = atoi(temp_conf.font_size);		
		}
		else if(!strncmp(text,"lcolor",6)) {
			strncpy(temp_conf.lcolor,"",4);
			for(i=7;i<strlen(text)-1;i++) {
				temp_conf.lcolor[i-7] = text[i];
			}
		}
		else if(!strncmp(text,"dec",3)) {
			strncpy(temp,"",100);
			for(i=4;i<strlen(text)-1;i++) {
				temp[i-4] = text[i];
			}	
			if((!strcmp(temp,"false"))) {
				temp_conf.decorated = FALSE; 
			}
			else {
				temp_conf.decorated = TRUE;
			}
		}
		else if(!strncmp(text,"bgcolor",7)) {
			strncpy(temp,"",100);
			for(i=8;i<strlen(text)-1;i++) {
				temp[i-8] = text[i];
			}
			gdk_color_parse(temp,&temp_conf.bgcolor);		
		}
		else if(!strncmp(text,"fgcolor",7)) {
			strncpy(temp,"",100);
			for(i=8;i<strlen(text)-1;i++) {
				temp[i-8] = text[i];
			}
			free(temp_conf.sfgcolor);
			temp_conf.sfgcolor = malloc(sizeof(char) * i);
			memcpy(temp_conf.sfgcolor,temp,i);
			gdk_color_parse(temp,&temp_conf.fgcolor);		
		}
		else if(!strncmp(text,"noquit",6)) {
			for(i=7;i<strlen(text)-1;i++) {
				temp[i-7] = text[i];
			}
			temp_conf.noquit = atoi(temp);
		}
		else if(!strncmp(text,"geom_x",6)) {
			for(i=7;i<strlen(text)-1;i++) {
				temp[i-7] = text[i];
			}
			temp_conf.geom_x = atoi(temp);
		}
		else if(!strncmp(text,"geom_y",6)) {
			for(i=7;i<strlen(text)-1;i++) {
				temp[i-7] = text[i];
			}
			temp_conf.geom_y = atoi(temp);
		}
		else if(!strncmp(text,"log",3)) {
			for(i=4;i<strlen(text)-1;i++) {
				temp[i-4] = text[i];
			}
			temp_conf.log = atoi(temp);
		}

	}

	fclose(fp); 
	return &temp_conf;
}

Config *read_default_config(char *feed_location)
{
	/* Set default config values */
	strcpy(temp_conf.feed_loc,"null");
	temp_conf.update = 15;
	temp_conf.font_size_i = 12;
	strcat(temp_conf.font_size,"12");
	strcpy(temp_conf.title,"a");
	strcpy(temp_conf.lcolor,"blue");
	temp_conf.decorated = TRUE;
	gdk_color_parse("white",&temp_conf.bgcolor);
	gdk_color_parse("black",&temp_conf.fgcolor);
	temp_conf.sfgcolor = malloc(sizeof(char) * 5);
	strcpy(temp_conf.sfgcolor,"black");
	temp_conf.noquit = 0;
	temp_conf.geom_x = 275;
	temp_conf.geom_y = 125;
	temp_conf.log = 0;
	strncpy(temp_conf.feed_loc,feed_location,100);

	return &temp_conf;
}
