/* Copyright 2004,2005,2006 Thomas "thisnukes4u" Coppi
   If you use this program, please send me an e-mail at thisnukes4u@gmail.com
   You may do whatever you wish with this program except for selling it, claiming it as your own,
   or modifying it without releasing the source code (the listed restrictions are not mutally exclusive,
   they all apply). If you do not agree with the above terms, you may optionally distribute and use 
   this software under the GNU GPL, the terms of which are included in the COPYING file */

#include <stdio.h>
#include <stdlib.h>

#include "rssfeed.h"
#include "error.h"
#include "log.h"
#include "config.h"

void gfeed_error(FILE *fp, unsigned int err_code)
{
	switch(err_code) {
		case MEM_ALLOC: write_log_item(fp,"ERROR:A memory allocation error has occured in gfeed.  gfeed will now bail out.");
				//exit(-1);
				break;
		case FEED_TYPE: write_log_item(fp,"ERROR:Document appears to be of the wrong type, not standard RSS or RDF file, but trying to parse anyway:");
				break;
		case RES_UNAV: write_log_item(fp,"ERROR:The file is unavailable, or is not really an RSS/RDF file.  Please check the URL and try again, or perhaps the location is down.");
				exit(-1);
			        break;
	}
}

