/* Copyright 2004,2005,2006 Thomas "thisnukes4u" Coppi
   If you use this program, please send me an e-mail at thisnukes4u@gmail.com
   You may do whatever you wish with this program except for selling it, claiming it as your own,
   or modifying it without releasing the source code (the listed restrictions are not mutally exclusive,
   they all apply). If you do not agree with the above terms, you may optionally distribute and use 
   this software under the GNU GPL, the terms of which are included in the COPYING file. */

#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <unistd.h>
#include <sys/stat.h>
#include <sys/types.h>

#include "rssfeed.h"
#include "conf.h"
#include "gui.h"
#include "error.h"
#include "config.h"

FILE *open_logfile(RssFeed *feed)
{
	FILE *logfile;
	char *home;
	char dotdir[200];
	char path[200];
	
	home = getenv("HOME");
	snprintf(dotdir,199,"%s/.gfeed",home);
	
	mkdir(dotdir,0);
	
	snprintf(path,199,"%s/.gfeed/%s.log",home,feed->channel_title);

	if((logfile = fopen(path, "a+")) == NULL) {
		logfile = stdout;
		fprintf(stderr, "Error opening logfile %s, logging to stdout...\n",path);
	}
	else
		printf("Opened logfile %s.\n",path);

	return logfile;
}

int write_log_raw(FILE *fp, char *log)
{
	if(fp) {
		fprintf(fp,"%s",log);
	}

	fsync((int)fp);

	return 0;
}

int write_log_item(FILE *fp, char *log)
{
	char timestring[100];
        struct tm *my_tm;
        time_t my_time;

        time(&my_time);

        my_tm = localtime(&my_time);

        strftime(timestring,99,"%b %d %Y %I:%M:%S",my_tm);

	if(fp) {
	        fprintf(fp,"%s - %s\n",timestring,log);
	}

	fsync((int)fp);

	return 0;
}

int write_log_comment(FILE *fp, char *log)
{
	if(fp) {
		fprintf(fp,"/* %s\n*/",log);
	}

	fsync((int)fp);

	return 0;
}

